-- Puffin: A Tojaso FowlPlay Project
-- Adapter component for class-specific configuration data such as raid frame indicators and click-casting

local Adapter_Classes = {}

local clicks = {
	RESET = {
			{ a = "shift-unit1" },
			{ a = "*unit2" },
			{ a = "*unit3" },
			{ a = "*unit4" },
			{ a = "type1", v = "target" },
			{ a = "type2" },
			{ a = "type3" },
			{ a = "type4" },
			{ a = "shift-type1" },
			{ a = "shift-type2" },
			{ a = "shift-type3" },
			{ a = "shift-type4" },
			{ a = "ctrl-type1", v = "menu" },
			{ a = "shift-spell1" },
			{ a = "shift-spell2" },
			{ a = "shift-spell3" },
			{ a = "shift-spell4" },
			{ a = "spell2" },
			{ a = "spell3" },
			{ a = "spell4" },
	},
	DRUID = {
		["Restoration"] = {
			{ a = "shift-unit1", v = "mouseover" },
			{ a = "*unit2", v = "mouseover" },
			{ a = "*unit3", v = "mouseover" },
			{ a = "*unit4", v = "mouseover" },
			{ a = "type1", v = "target" },
			{ a = "type2", v = "spell" },
			{ a = "type3", v = "spell" },
			{ a = "type4", v = "spell" },
			{ a = "shift-type1", v = "spell" },
			{ a = "shift-type2", v = "spell" },
			{ a = "shift-type3", v = "spell" },
			{ a = "shift-type4", v = "spell" },
			{ a = "ctrl-type1", v = "menu" },
			{ a = "shift-spell1", v = "Nourish" },
			{ a = "shift-spell2", v = "Regrowth" },
			{ a = "shift-spell3", v = "Swiftmend" },
			{ a = "shift-spell4", v = "Cenarion Ward" },
			{ a = "spell2", v = "Rejuvenation" },
			{ a = "spell3", v = "Wild Growth" },
			{ a = "spell4", v = "Lifebloom" },
		},
		["Balance"] = {
			{ a = "shift-unit1", v = "mouseover" },
			{ a = "*unit2", v = "mouseover" },
			{ a = "*unit3", v = "mouseover" },
			{ a = "*unit4", v = "mouseover" },
			{ a = "type1", v = "target" },
			{ a = "type2", v = "spell" },
			{ a = "type3", v = "spell" },
			{ a = "type4", v = "spell" },
			{ a = "ctrl-type1", v = "menu" },
			{ a = "spell2", v = "Rejuvenation" },
			{ a = "spell3", v = "Healing Touch" },
			{ a = "spell4", v = "Cenarion Ward" },
		},		
	},
	PRIEST = {
		["Holy"] = {
			{ a = "shift-unit1", v = "mouseover" },
			{ a = "*unit2", v = "mouseover" },
			{ a = "*unit3", v = "mouseover" },
			{ a = "*unit4", v = "mouseover" },
			{ a = "type1", v = "target" },
			{ a = "type2", v = "spell" },
			{ a = "type3", v = "spell" },
			{ a = "type4", v = "spell" },
			{ a = "shift-type1", v = "spell" },
			{ a = "shift-type2", v = "macro" },
			{ a = "shift-type3", v = "spell" },
			{ a = "shift-type4", v = "spell" },
			{ a = "ctrl-type1", v = "menu" },
			{ a = "shift-spell1", v = "Heal" },
			{ a = "shift-spell2", v = "Flash Heal" },
			{ a = "shift-spell3", v = "Greater Heal" },
			{ a = "shift-spell4", v = "Binding Heal" },
			{ a = "spell2", v = "Renew" },
			{ a = "spell3", v = "Prayer of Mending" },
			{ a = "spell4", v = "Power Word: Shield" },
			{ a = "shift-macrotext2", v = '/run sfx=GetCVar("Sound_EnableSFX")\n/console Sound_EnableSFX 0\n/cast Power Infusion\n/run UIErrorsFrame:Clear()\n/run SetCVar("Sound_EnableSFX",sfx)\n/cast [target=mouseover] Flash Heal' },
		},
		["Shadow"] = {
			{ a = "shift-unit1", v = "mouseover" },
			{ a = "*unit2", v = "mouseover" },
			{ a = "*unit3", v = "mouseover" },
			{ a = "*unit4", v = "mouseover" },
			{ a = "type1", v = "target" },
			{ a = "type2", v = "spell" },
			{ a = "type3", v = "spell" },
			{ a = "type4", v = "spell" },
			{ a = "shift-type2", v = "spell" },
			{ a = "shift-type4", v = "spell" },
			{ a = "ctrl-type1", v = "menu" },
			{ a = "shift-spell2", v = "Flash Heal" },
			{ a = "shift-spell4", v = "Binding Heal" },
			{ a = "spell2", v = "Renew" },
			{ a = "spell3", v = "Prayer of Mending" },
			{ a = "spell4", v = "Power Word: Shield" },
		},		
	},
	MONK = {
		["Mistweaver"] = {
			{ a = "shift-unit1", v = "mouseover" },
			{ a = "*unit2", v = "mouseover" },
			{ a = "*unit3", v = "mouseover" },
			{ a = "*unit4", v = "mouseover" },
			{ a = "type1", v = "target" },
			{ a = "type2", v = "spell" },
			{ a = "type3", v = "spell" },
			{ a = "type4", v = "spell" },
--			{ a = "shift-type1", v = "spell" },
			{ a = "shift-type2", v = "spell" },
			{ a = "shift-type3", v = "spell" },
--			{ a = "shift-type4", v = "spell" },
			{ a = "ctrl-type1", v = "menu" },
--			{ a = "shift-spell1", v = "" },
			{ a = "shift-spell2", v = "Surging Mist" },
			{ a = "shift-spell3", v = "Enveloping Mist" },
--			{ a = "shift-spell4", v = "" },
			{ a = "spell2", v = "Renewing Mist" },
			{ a = "spell3", v = "Soothing Mist" },
			{ a = "spell4", v = "Chi Burst" },
		},
	},
}

-- Add default and layout configuration data to the database
function Adapter_Classes.OnEnable()
	local EF = Puffin.ErrorFormat
	local DB = Puffin.Component("Data") -- link to data management functions
	assert(DB, EF("Adapter_Classes", "Data component not found"))
	
	local class = Puffin.myClass -- set up entries in configuration database for player's class
	
	DB.AllocateDatabase("clicks", false)
	local cc = clicks[class]
	if cc then
		for spec, ctable in pairs(cc) do DB.SetRecord("clicks", spec, ctable) end
	end
	DB.SetRecord("clicks", "RESET", clicks.RESET) -- can be used to clear clicking attributes
end

Puffin.RegisterComponent("Adapter_Classes", Adapter_Classes, "ADAPTER", 0)
