-- Puffin: A Tojaso FowlPlay Project
-- Model component for communicating with data broker addons

local Model_DataBrokers = {}
local DB = nil
local LDB = nil

-- LDB callback for new data brokers
function Model_DataBrokers:LibDataBroker_DataObjectCreated(event, name, broker)
	LDB.RegisterCallback(self, "LibDataBroker_AttributeChanged", "AttributeChanged")
	DB.SetAttribute("brokers", name, "broker", broker)
	Puffin.Callback("Broker_Created", name)
end

-- LDB callback for updated attributes
function Model_DataBrokers:AttributeChanged(event, name, key, value, broker)
	if broker then Puffin.Callback("Broker_Changed", name, key) end
end

function Model_DataBrokers.OnEnable()
	LDB = LibStub("LibDataBroker-1.1", true)
	assert(LDB, "Puffin.Model_DataBrokers: cannot open LibDataBroker-1.1")

	DB = Puffin.Component("Data") -- link to data management functions
	assert(DB, "Puffin.Model_DataBrokers: invalid reference to data management component")
	DB.AllocateDatabase("brokers", false)
	
	for name, broker in LDB:DataObjectIterator() do Model_DataBrokers:LibDataBroker_DataObjectCreated(nil, name, broker) end
	LDB.RegisterCallback(Model_DataBrokers, "LibDataBroker_DataObjectCreated")
end

Puffin.RegisterComponent("Model_DataBrokers", Model_DataBrokers, "MODEL", 5)
